$(document).ready(init);

//En fonction du support, évènement click ou touchend
var _clickTouch;
var _mobile = false;

var _spectre, ctx_spectre, _formes, ctx_formes;
var r, g, b;
var posX;
var scale, scale_save=1;
var cpt = 0;
function init() {	
	// Si on est sur mobile ou non	
	if(navigator.userAgent.match("Mobile") || navigator.userAgent.match("Android"))
		_mobile = true;
	
	// Evenement click si on se trouve sur PC et touchend sur mobile
	_clickTouch = ((_mobile == true) ? "touchend" : "click");
	
	_spectre = $("#spectre");
	ctx_spectre = _spectre[0].getContext("2d");
	
	setTimeout(function(){
	 	lanchAnim();
	}, 5000);
	$('#anim').click(lanchAnim);
	function lanchAnim(){
		$('#anim').animate({width:'330px', left:'600px', top:'60px'}, 500);
		$('#anim').unbind('click');
		$('#anim').css('cursor', 'default');
		setTimeout(function(){
			$('#experience').animate({opacity:'1'}, 500);
		}, 200);
	}
	
	$('#formesMask').mousemove(function(ev){
		var width = Number($(this).css('width').replace(/[^-\d\.]/g, ''));
		var offset = $(this).offset();
		var x = (ev.pageX - offset.left-width/2)*6/(width/2)+.4;
		$('#txtX').text(x.toFixed(1).replace(".", ","));
	});
	
	var img = new Image();
	img.src = './img/spectre.png';
	img.onload = function(){
		ctx_spectre.drawImage(img, 0, 0);
	}
	
	
	$('#formes').append('<div id="ovalCentral" class="oval"></div>');
	for(i=0; i<26; i++){
		$('#formes').append('<div id="ovalPlus'+i+'" class="oval simple"></div>');
		$('#formes').append('<div id="ovalMoins'+i+'" class="oval simple"></div>');
	}
	setTimeout(function() {
		getCouleur();
		tracerFormes();
	}, 1000);
	getCouleur();
	tracerFormes();
	$('#spectre_curseur').draggable({
		axis: 'x',
		containment: [60, 0, 578, 0],
		drag: function(){
			getCouleur();
			tracerFormes();
			var lambda = 380 + (760 - 380) * ($(this).position().left - 24)/(578-60);
			$('#txtLambda').text(parseInt(lambda));
		}
	});
	
	$('.cursJaune').each(function(){
		$(this).draggable({
			containment: $(this).closest('.cursor'),
			drag: function(){
				tracerFormes();
				if($(this).closest('.cursor').attr('id') == 'cursAlpha'){
					var alpha = 100 + (200 - 100) * $(this).position().left/($(this).closest('.cursor').width() - $(this).width());
					$('#txtAlpha').text(parseInt(alpha));
				}else{
					var d = 1 + (3 - 1) * $(this).position().left/($(this).closest('.cursor').width() - $(this).width());
					$('#txtD').text(d.toFixed(1).replace(".", ","));
				}
			}
		});
	});	
}

function getCouleur(){
	posX = $('#spectre_curseur').position().left-24;
	//scale = 2 + posX/$('#spectre_curseur').width();
	// On récupère la couleur (en RGB) se trouvant à la position du curseur (posX), en son milieu (37, soit la moitié de la hauteur du spectre) et sur 1*1px
	var imgd = ctx_spectre.getImageData(posX, 37, 1, 1).data;
	for (var i=0; i<imgd.length; i+=4) {
		// Pour évincer la couleur noire du spectre
		if (imgd[i]==0 && imgd[i+1]==0 && imgd[i+2]==0){
			r = 73;
			g = 10;
			b = 9;
		}else{
			r = imgd[i];
			g = imgd[i+1];
			b = imgd[i+2];
		}
	}
}

function tracerFormes(){	
	if(cpt == 0){	
		var longOnde = Number($('#txtLambda').text());
		var epais = Number($('#txtAlpha').text().replace(",", "."));
		var dist = Number($('#txtD').text().replace(",", "."));
		var color = 'rgb('+r+', '+g+', '+b+')';
		var epaisMetre = Number(epais/1000000);
		var lambdaMetre = Number(Math.pow(10, -9) * longOnde);
		var espacement = (400/19) * 0.22143*lambdaMetre*dist / (Math.PI * epaisMetre) * 1000;
		var intensite =  (lambdaMetre*dist) / (10*epaisMetre) * 1000;
		console.log(intensite);
		
		/*var maWidth = Number((($('#axefond_noir').width()-40)/30) * 2 * longOnde * dist / (10 * epais));
		var maHeight = Number($('#ovalCentral').height());*/
		
		var maWidth =  Number(intensite * 18); 
		var monLeft = 165 - maWidth/2;
		$('#ovalCentral').css('width', maWidth+'px');
		$('#ovalCentral').css('left', monLeft+'px');
		
		$('.oval.simple').css('width', Number(maWidth/2)+'px');
		
		for(i=0; i<32; i++){
			$('#ovalPlus'+i).css('width', maWidth+'px');
			$('#ovalMoins'+i).css('width', maWidth+'px');
			$('#ovalPlus'+i).css('left', Number(monLeft+(i+1)*(maWidth+espacement))+'px');
			$('#ovalMoins'+i).css('left', Number(monLeft-(i+1)*(maWidth+espacement))+'px');
		}
		
		/*var widthGrand = Number(maWidth/2)+'px \/ '+Number(maHeight/2)+'px';
		var widthPetit = Number(maWidth/4)+'px \/ '+Number(maHeight/2)+'px';
		
		$('#ovalCentral').css('-webkit-border-radius', widthGrand);
		$('#ovalCentral').css('-moz-border-radius', widthGrand);
		$('#ovalCentral').css('border-radius', widthGrand);*/
		$('.oval').css('background-color', color);
		/*$('.oval').css('background', '-webkit-linear-gradient(right, black, red, black)');
		$('.oval').css('background', '-o-linear-gradient(right, black, red, black)');
		$('.oval').css('background', '-moz-linear-gradient(right, black, red, black)');
		$('.oval').css('background', 'linear-gradient(right, black, red, black)');*/
		/*$('.oval').css('background', '-o-radial-gradient('+color+')');
		$('.oval').css('background', '-moz-radial-gradient('+color+')');
		$('.oval').css('background', 'radial-gradient('+color+')');*/
		
		/*$('.oval.simple').css('-webkit-border-radius', widthPetit);
		$('.oval.simple').css('-moz-border-radius', widthPetit);
		$('.oval.simple').css('border-radius', widthPetit);*/
	}else if(cpt == 2){
		cpt = 0;
	}else{
		cpt++;
	}
}